PHP中的异常处理机制解析

码农公社  210.net.cn   210是何含义?10月24日是程序员节,1024 = 210、210既 210 之意。

PHP中的异常处理机制解析


1、异常概述

异常(Exception)是一种错误处理机制,用于在指定的错误发生时改变脚本的正常流程。

当异常被触发时,当前代码状态被保存,代码执行被切换到预定义的异常处理器函数(如果有)

根据情况,处理器或重新开始执行代码,或从代码中另外的位置继续执行脚本,或终止脚本执行,


2、异常的基本使用

当异常被抛出时,其后的代码不会继续执行,PHP会尝试查找匹配的 "catch" 代码块。

如果异常没有被捕获,而且又没用使用 set_exception_handler() 作相应的处理,那么将发生一个严重的错误(致命错误),

并且输出 "Uncaught Exception" (未捕获异常)的错误消息。

尝试抛出一个异常,同时不去捕获它

//create function with an exception
function checkNum($number){
 if($number>1){
  throw new Exception("Value must be 1 or below");
 }
}
//trigger exception
checkNum(2);

上面的代码会获得类似这样的一个错误:

Fatal error: Uncaught exception 'Exception' with message 'Value must be 1 or below' in C:webfolder est.php:6

Stack trace: #0 C:webfolder est.php(12):checkNum(28) #1 {main} thrown in C:webfolder est.php on line 6


注意:PHP默认是警告模式,如果需要对系统错误使用异常处理机制,则要在处理代码之前设置错误处理模式

set_error_handler(function(){

 throw new Exception('错误!');

});


3、Try, throw 和 catch

正确的处理程序应当包括:

Try - 使用异常的函数应该位于 "try" 代码块内。如果没有触发异常,则代码将照常继续执行。但是如果异常被触发,会抛出一个异常。

Throw - 这里规定如何触发异常。每一个 "throw" 必须对应至少一个 "catch"。

Catch - "catch" 代码块会捕获异常,并创建一个包含异常信息的对象。

//创建可抛出一个异常的函数

function checkNum($number){
 if($number>1){
  throw new Exception("Value must be 1 or below");
 }
}
//在 "try" 代码块中触发异常
try{
 checkNum(2);
}catch(Exception $e) { //捕获异常
 echo 'File: '.$e->getFile().' line: '.$e->getLine().'<br>';
 die('Message: '.$e->getMessage());
}

上面代码将获得类似这样一个错误:

File: E:webdevwwwpdo3.php line: 7

Message: Value must be 1 or below


代码解析:创建checkNum()函数。它检测数字是否大于1。如果是,则抛出一个异常。

在 "try" 代码块中调用 checkNum(),函数checkNum() 函数中的异常被抛出,"catch" 代码块接收到该异常,

并创建一个包含异常信息的对象 ($e)。

通过从这个 exception 对象输出来自该异常的错误消息。


不过,为了遵循“每个 throw 必须对应一个 catch”的原则,可以设置一个顶层的异常处理器来处理漏掉的错误,见第7点。


4、创建自定义的异常处理器

创建一个专门的类,当发生异常时可调用其函数。

该类必须是 exception 类的一个扩展。

这个自定义的exception类继承了PHP的exception类的所有属性,可向其添加自定义的函数。

class customException extends Exception{
 public function errorMessage(){
  return 'Error on line '.$this->getLine().' in '.$this->getFile().': <b>'.$this->getMessage().'</b> is not a valid E-Mail address';
 }
}
$email = "someone@example...com";
try{
 //使用PHP过滤器验证邮箱有效性
 if(filter_var($email, FILTER_VALIDATE_EMAIL) === FALSE){ 
  throw new customException($email);
 }
}catch (customException $e){
 echo $e->errorMessage();
}

这个新类是旧的exception类的副本,外加 errorMessage()函数。

正因为它是旧类的副本,它从旧类继承了属性和方法,我们可以使用exception类的方法,比如 getLine()、getFile()以及getMessage()。

上面的代码抛出了一个异常,并通过一个自定义的 exception 类来捕获它:创建 errorMessage() 函数。

如果 e-mail 地址不合法,则该函数返回一条错误消息。


5、多个异常的捕获

可以为一段脚本使用多个异常,来检测多种情况。

可以使用多个if..else代码块,或一个switch代码块,或者嵌套多个异常。

这些异常能够使用不同的 exception 类,并返回不同的错误消息:

class customException extends Exception{
  public function errorMessage(){
    return = 'Error on line '.$this->getLine().' in '.$this->getFile().': <b>'.$this->getMessage().'</b> is not a valid E-Mail address';
  }
}
$email = "someone@168.cx";
try{
  if(filter_var($email, FILTER_VALIDATE_EMAIL) === FALSE){
    throw new customException($email);
  }
  //check for "example" in mail address
  if(strpos($email, "example") !== FALSE){
    throw new Exception("$email is an example e-mail");
  }
} catch (customException $e){
  echo $e->errorMessage();
}catch(Exception $e){
  echo $e->getMessage();
}

上面的代码测试了两种条件,如何任何条件不成立,则抛出一个异常:

执行 "try" 代码块,在第一个条件下,不会抛出异常。

由于 e-mail 含有字符串 "example",第二个条件会触发异常。

"catch" 代码块会捕获异常,并显示恰当的错误消息,如果没有捕获customException,只捕获了 base exception,则在那里处理异常。


6、重新抛出异常

有时,当异常被抛出时,也许希望以不同于标准的方式对它进行处理。

可以在一个 “catch” 代码块中再次抛出异常。脚本应该对用户隐藏系统错误。

对程序员来说,系统错误也许很重要,但是用户对它们并不感兴趣。

为了让用户更容易使用,可以再次抛出带有对用户比较友好的消息的异常:

class customException extends Exception{
  public function errorMessage(){
    return $this->getMessage().' is not a valid E-Mail address.';
  }
}
$email = "someone@168.cx";
try{
  try{
    if(strpos($email, "example") !== FALSE){
      throw new Exception($email);
    }
  }catch(Exception $e){
    //re-throw exception
    throw new customException($email);
  }
}catch (customException $e){
  //display custom message
  echo $e->errorMessage();
}

上面的代码检测在邮件地址中是否含有字符串 "example"。如果有,则再次抛出异常:


把 $email 变量设置为一个有效的邮件地址,但含有字符串 "example"。

"try" 代码块包含另一个 "try" 代码块,这样就可以再次抛出异常。

由于 e-mail 包含字符串 "example",因此触发异常。

"catch" 捕获到该异常,并重新抛出 "customException"。

捕获到 "customException",并显示一条错误消息。

如果在其目前的 "try" 代码块中异常没有被捕获,则它将在更高层级上查找 catch 代码块。


7、设置顶层异常处理器

set_exception_handler() 函数可设置处理所有未捕获异常的用户定义函数

function myException($exception){
  echo "<b>Exception:</b> " , $exception->getMessage();
}
set_exception_handler('myException');
throw new Exception('Uncaught Exception occurred');

以上代码的输出应该类似这样:


Exception: Uncaught Exception occurred


在上面的代码中,不存在 "catch" 代码块,而是触发顶层的异常处理程序。

应该使用此函数来捕获所有未被捕获的异常。

但是对于系统自动抛出的错误,会先经过set_error_handler处理并抛出异常才能被set_exception_handler处理

function myException($exception){
  echo "<b>Exception:</b> " , $exception->getMessage();
}
set_exception_handler('myException');
set_error_handler(function(){
  throw new Exception('错误!');
});
echo 10/0; //触发被除数不能为0的警告


代码执行结果:Exception: 错误!





原文:https://juejin.im/post/6893305918243471373


评论